import crypt
import libuser
import unittest

def prompt_callback(prompts):
    for p in prompts:
        if p.key == 'ldap/password':
            p.value = 'password'
        else:
            p.value = p.default_value

# This is ugly; ideally we would want a separate connection for each test case,
# but libssl REALLY doesn't like being unloaded (libcrypto is not unloaded
# and keeps pointers to unloaded libssl)
admin = libuser.admin(prompt = prompt_callback)

# Test case order matches the order of function pointers in struct lu_module
class Tests(unittest.TestCase):
    def setUp(self):
        # See the comment at the libuser.admin() call above
        self.a = admin

    def testGroupAddDefault(self):
        # Add an group with default attributes
        e = self.a.initGroup('group_default')
        self.a.addGroup(e)
        del e

    def testUserAddDefault(self):
        # Add an user with default attributes
        e = self.a.initUser('user_default')
        self.a.addUser(e, False, False)
        del e

    def tearDown(self):
        del self.a


if __name__ == '__main__':
    unittest.main()
